package com.ejie.ab79.service.actuaciones;

import com.ejie.ab79.dao.actuaciones.TiposActuacionDao;
import com.ejie.ab79.model.actuaciones.TiposActuacion;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableResponseDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * TiposActuacionServiceImpl  
 * 
 *  
 */

@Service(value = "tiposActuacionService")
public class TiposActuacionServiceImpl implements TiposActuacionService {

	@Autowired
	private TiposActuacionDao tiposActuacionDao;

	/**
	 * Inserts a single row in the TiposActuacion table.
	 *
	 * @param tiposActuacion
	 *            TiposActuacion
	 * @return TiposActuacion
	 */
	@Transactional(rollbackFor = Throwable.class)
	public TiposActuacion add(TiposActuacion tiposActuacion) {
		return this.tiposActuacionDao.add(tiposActuacion);
	}

	/**
	 * Updates a single row in the TiposActuacion table.
	 *
	 * @param tiposActuacion
	 *            TiposActuacion
	 * @return TiposActuacion
	 */
	@Transactional(rollbackFor = Throwable.class)
	public TiposActuacion update(TiposActuacion tiposActuacion) {
		return this.tiposActuacionDao.update(tiposActuacion);
	}

	/**
	 * Finds a single row in the TiposActuacion table.
	 *
	 * @param tiposActuacion
	 *            TiposActuacion
	 * @return TiposActuacion
	 */
	public TiposActuacion find(TiposActuacion tiposActuacion) {
		return (TiposActuacion) this.tiposActuacionDao.find(tiposActuacion);
	}

	/**
	 * Deletes a single row in the TiposActuacion table.
	 *
	 * @param tiposActuacion
	 *            TiposActuacion
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(TiposActuacion tiposActuacion) {
		this.tiposActuacionDao.remove(tiposActuacion);
	}

	/**
	 * Finds a list of rows in the TiposActuacion table.
	 *
	 * @param tiposActuacion
	 *            TiposActuacion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<TiposActuacion>
	 */
	public List<TiposActuacion> findAll(TiposActuacion tiposActuacion, TableRequestDto tableRequestDto) {
		return (List<TiposActuacion>) this.tiposActuacionDao.findAll(tiposActuacion, tableRequestDto);
	}

	/**
	 * Finds rows in the TiposActuacion table using like.
	 *
	 * @param tiposActuacion
	 *            TiposActuacion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TiposActuacion>
	 */
	public List<TiposActuacion> findAllLike(TiposActuacion tiposActuacion, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		return (List<TiposActuacion>) this.tiposActuacionDao.findAllLike(tiposActuacion, tableRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the TiposActuacion table.
	 *
	 * @param filterTiposActuacion
	 *            TiposActuacion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	public void removeMultiple(TiposActuacion filterTiposActuacion, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		this.tiposActuacionDao.removeMultiple(filterTiposActuacion, tableRequestDto, startsWith);
	}

	/**
	 * Filter method in the TiposActuacion table.
	 *
	 * @param filterTiposActuacion
	 *            TiposActuacion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return TableResponseDto<TiposActuacion>
	 */
	public TableResponseDto<TiposActuacion> filter(TiposActuacion filterTiposActuacion, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		List<TiposActuacion> listaTiposActuacion = this.tiposActuacionDao.findAllLike(filterTiposActuacion,
				tableRequestDto, false);
		Long recordNum = this.tiposActuacionDao
				.findAllLikeCount(filterTiposActuacion != null ? filterTiposActuacion : new TiposActuacion(), false);

		TableResponseDto<TiposActuacion> usuarioDto = new TableResponseDto<TiposActuacion>(tableRequestDto, recordNum,
				listaTiposActuacion);

		if (tableRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<TiposActuacion>> reorderSelection = this.tiposActuacionDao
					.reorderSelection(filterTiposActuacion, tableRequestDto, startsWith);
			usuarioDto.setReorderedSelection(reorderSelection);
			usuarioDto.addAdditionalParam("reorderedSelection", reorderSelection);
			usuarioDto.addAdditionalParam("selectedAll", tableRequestDto.getMultiselection().getSelectedAll());
		}
		if (tableRequestDto.getSeeker().getSelectedIds() != null) {
			tableRequestDto.setMultiselection(tableRequestDto.getSeeker());
			List<TableRowDto<TiposActuacion>> reorderSeeker = this.tiposActuacionDao
					.reorderSelection(filterTiposActuacion, tableRequestDto, startsWith);
			usuarioDto.setReorderedSeeker(reorderSeeker);
			usuarioDto.addAdditionalParam("reorderedSeeker", reorderSeeker);
		}
		return usuarioDto;
	}

	/**
	 * Searches rows in the TiposActuacion table.
	 *
	 * @param filterTiposActuacion
	 *            TiposActuacion
	 * @param searchTiposActuacion
	 *            TiposActuacion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<TiposActuacion>>
	 */
	public List<TableRowDto<TiposActuacion>> search(TiposActuacion filterTiposActuacion,
			TiposActuacion searchTiposActuacion, TableRequestDto tableRequestDto, Boolean startsWith) {
		return this.tiposActuacionDao.search(filterTiposActuacion, searchTiposActuacion, tableRequestDto, startsWith);
	}

	/**
	 * Reorder the selection made in TiposActuacion table.
	 *
	 * @param filterTiposActuacion
	 *            TiposActuacion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	public Object reorderSelection(TiposActuacion filterTiposActuacion, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		return this.tiposActuacionDao.reorderSelection(filterTiposActuacion, tableRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the TiposActuacion table.
	 *
	 * @param filterTiposActuacion
	 *            TiposActuacion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return TableResponseDto<JerarquiaDto<TiposActuacion>>
	 */
	public TableResponseDto<JerarquiaDto<TiposActuacion>> jerarquia(TiposActuacion filterTiposActuacion,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		List<JerarquiaDto<TiposActuacion>> listaTiposActuacion = this.tiposActuacionDao
				.findAllLikeJerarquia(filterTiposActuacion, tableRequestDto);
		Long recordNum = this.tiposActuacionDao.findAllLikeCountJerarquia(filterTiposActuacion, tableRequestDto);
		return new TableResponseDto<JerarquiaDto<TiposActuacion>>(tableRequestDto, recordNum, listaTiposActuacion);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the TiposActuacion
	 * table.
	 *
	 * @param filterTiposActuacion
	 *            TiposActuacion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return TableResponseDto<JerarquiaDto<TiposActuacion>>
	 */
	public TableResponseDto<JerarquiaDto<TiposActuacion>> jerarquiaChildren(TiposActuacion filterTiposActuacion,
			TableRequestDto tableRequestDto) {
		TableResponseDto<JerarquiaDto<TiposActuacion>> tableResponseDto = new TableResponseDto<JerarquiaDto<TiposActuacion>>();
		tableResponseDto.addAdditionalParam(TableResponseDto.CHILDREN,
				this.tiposActuacionDao.findAllChild(filterTiposActuacion, tableRequestDto));
		return tableResponseDto;
	}

	/**
	 * Exporta Datos al clipBoard
	 *
	 */
	public List<TiposActuacion> getMultiple(TiposActuacion filterTiposActuacion, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		return this.tiposActuacionDao.getMultiple(filterTiposActuacion, tableRequestDto, startsWith);
	}

}
